# /packages/intranet-budget/lib/budget-tree_component.tcl
#
# Copyright (C) 2012-2020 ]project-open[
#
# All rights reserved. Please check
# http://www.project-open.com/license/ for details.

# ----------------------------------------------------------------------
# 
# ---------------------------------------------------------------------

# The following variables are expected in the environment
# defined by the calling /tcl/*.tcl libary:
#	project_id
#	diagram_title
#	diagram_width
#	diagram_height

if {![info exists diagram_width]} { set diagram_width 600 }
if {![info exists diagram_height]} { set diagram_height 300 }
if {![info exists diagram_title]} { set diagram_title "" }
set main_project_id $project_id

set show_diagram_p 1
set show_debug_p 0

# Create a random ID for the budget_tree
set budget_tree_rand [expr {round(rand() * 100000000.0)}]
set budget_tree_id "budget_tree_$budget_tree_rand"



set data_list {}

# Cost Types
set cost_type_ids [im_budget_item_rollup_cost_type_ids]
set cti_columns {}
foreach cti $cost_type_ids {
    lappend cti_columns "        {text: '[im_category_from_id $cti]', coltype: 'actuals', flex: 1, dataIndex: 'cost_type_$cti', sortable: false},"
}
set cost_type_actuals_columns [join $cti_columns "\n"]

# Create a debug JSON object that controls logging verbosity
set debug_default "default 0"
set debug_list [parameter::get_from_package_key -package_key "intranet-gantt-editor" -parameter DebugHash -default $debug_default]
array set debug_hash $debug_list
set debug_json_list {}
foreach id [array names debug_hash] { lappend debug_json_list "'$id': $debug_hash($id)" }
set debug_json "{\n\t[join $debug_json_list ",\n\t"]\n}"

