-- /packages/intranet-budget/sql/postgres/intranet-budget-drop.sql
--
-- Copyright (c) 2007 ]project-open[
-- All rights reserved.
--
-- @author	frank.bergmann@project-open.com

-- Drop plugins and menus for the module
--

select  im_component_plugin__del_module('intranet-budget');
select  im_menu__del_module('intranet-budget');

delete from im_biz_object_urls where object_type = 'im_budget_item';

drop view if exists im_budget_version_status;
drop view if exists im_budget_version_type;
drop view if exists im_budget_item_status;
drop view if exists im_budget_item_type;

delete from im_budget_items;


delete from im_category_hierarchy where parent_id in (select category_id from im_categories where category_type = 'Intranet Budget Item Status');
delete from im_category_hierarchy where parent_id in (select category_id from im_categories where category_type = 'Intranet Budget Item Type');
delete from im_category_hierarchy where child_id in (select category_id from im_categories where category_type = 'Intranet Budget Item Status');
delete from im_category_hierarchy where child_id in (select category_id from im_categories where category_type = 'Intranet Budget Item Type');

delete from im_dynfield_type_attribute_map where object_type_id in (select category_id from im_categories where category_type = 'Intranet Budget Item Type');

delete from im_categories where category_type = 'Intranet Budget Item Status';
delete from im_categories where category_type = 'Intranet Budget Item Type';


delete from im_biz_object_role_map where acs_object_type = 'im_budget_item';
delete from im_categories where category = 'Budget Item Manager' and category_type = 'Intranet Biz Object Role';


drop function if exists im_budget_item_insert_tr() CASCADE;
drop function if exists im_budget_items_update_tr () CASCADE;
drop function if exists im_budget_item__new (
	integer, varchar, timestamptz, integer, varchar, integer,
	varchar, varchar, varchar, integer, integer
);


drop function if exists im_budget_item__new(
	integer, varchar, timestamptz, integer, varchar, integer,
	varchar, varchar, integer, integer, integer, integer
);
drop function if exists im_budget_item__delete(integer);
drop function if exists im_budget_item__name (integer);
drop function if exists im_budget_item_name_from_id (integer);
drop function if exists im_budget_item_nr_from_id (integer);

drop function if exists im_budget_item_nr_parent_list(integer, varchar, integer);
drop function if exists im_budget_item_nr_parent_list(integer);
drop function if exists im_budget_items_tsearch() CASCADE;

drop function if exists im_budget_version__delete(integer);
drop function if exists im_budget_version__name(integer);
drop function if exists im_budget_version__new (integer, varchar, timestamptz, integer, varchar, integer,varchar, varchar, integer, integer, integer);

drop function if exists im_budget_item_project_rel__delete(integer);
drop function if exists im_budget_item_project_rel__delete(integer, integer);
drop function if exists im_budget_item_project_rel__new (integer, varchar, integer, integer, integer, integer, varchar, integer);



alter table im_costs drop column budget_item_id;
alter table im_invoice_items drop column budget_item_id;

drop table if exists im_budget_versions CASCADE;
drop table if exists im_budget_items CASCADE;

select acs_rel_type__drop_role ('im_budget_item_project_rel');
delete from acs_rel_types where rel_type = 'im_budget_item_project_rel';


drop table if exists im_budget_item_project_rels cascade;


delete from im_dynfield_layout where attribute_id in (
       select attribute_id from im_dynfield_attributes where acs_attribute_id in (select attribute_id from acs_attributes where object_type = 'im_budget_item')
);
delete from im_dynfield_attributes where acs_attribute_id in (select attribute_id from acs_attributes where object_type = 'im_budget_item');
delete from acs_attributes where object_type = 'im_budget_item';


delete from acs_object_type_tables where object_type = 'im_budget_item';

delete from acs_object_types where object_type = 'im_budget_item';
select acs_object_type__drop_type ('im_budget_item', 'f');
