# /packages/intranet-budget/www/associate.tcl
#
# Copyright (C) 2010 ]project-open[
#
# All rights reserved. Please check
# http://www.project-open.com/license/ for details.

ad_page_contract {
    Allow the user to associate the current ticket with a new object
    using an OpenACS relationship.
    @author frank.bergmann@project-open.com
} {
    { bid ""}
    { return_url "/intranet-budget/index" }
}

# ---------------------------------------------------------------
# Defaults & Security
# ---------------------------------------------------------------

set current_user_id [auth::require_login]
set page_title [lang::message::lookup "" intranet-budget.Associate_Budget_Item_With_Other_Object "Associate Budget Item With Another Object"]
set context_bar [im_context_bar $page_title]
set page_focus "im_header_form.keywords"
set action_forbidden_msg [lang::message::lookup "" intranet-budget.Action_Forbidden "<b>Unable to execute action</b>:<br>You don't have the permissions to associated this budget item with other objects."]

# Check that the user has write permissions on all select tickets
foreach budget_item_id $bid {

    # Check that ticket_id is an integer
    im_security_alert_check_integer -location "Budget: Associate" -value $budget_item_id

    im_budget_item_permissions $current_user_id $budget_item_id view read write admin
    if {!$write} { ad_return_complaint 1 $action_forbidden_msg }
}

set first_budget_item_id [lindex $bid 0]

