

set cost_type_ids [im_budget_item_rollup_cost_type_ids]
set match_fields {match_cost_type_id match_expense_type_id match_material_type_id match_task_id match_user_id}

set cti_fields {}
foreach cti $cost_type_ids { lappend cti_fields "        'cost_type_$cti'," }
foreach match_field $match_fields { lappend cti_fields "        '$match_field'," }

doc_return 200 "application/javascript" "\
// /sencha-core/www/model/BudgetItem.js
//
// Copyright (C) 2013-2020 \]project-open\[
//
// All rights reserved. Please see
// http://www.project-open.com/license/ for details.


/**
 * BudgetItem represents one line of a (project) budget.
**/

Ext.define('PO.budget.BudgetTreeItem', {
    extend: 'PO.model.finance.BudgetItem',
    xtype: 'budgetTreeItem',
    fields: \[
	'id',
	'name',
	'nr',

        'cost_id',
        'cost_name',
        'cost_nr',
        'cost_center_id',
        'cost_status_id',
        'cost_type_id',
        'amount',
        'vat',
        'tax',
        'currency',
        'effective_date',
        'customer_id',
        'provider_id',
        'project_id',
[join $cti_fields "\n"]
        'object_type_id',
        'object_status_id'
    \]

// Fields included in base class
//      'id'
//      'object_type'
//      'description',
//      'note',

});

"

