# /packages/intranet-budget/www/project-phases.html.tcl
#
# Copyright (C) 2003-2018 ]project-open[
#
# All rights reserved. Please check
# http://www.project-open.com/license/ for details.

ad_page_contract {
    Returns a JSON with the project phases of a specific project
        @author frank.bergmann@project-open.com
} {
    project_id:integer
}

set current_user_id [auth::require_login]
im_project_permissions $current_user_id $project_id view_p read_p write_p admin_p

set options_html "<option value=''></option>\n"
if {$read_p} {
    set phases_sql "
	select	p.*
	from	im_projects p
	where	p.parent_id = :project_id
	order by p.sort_order
    "
    db_foreach phases $phases_sql {
	append options_html "<option value='$project_id'>$project_name</option>\n"
    }
}

doc_return 200 "text/html" $options_html
