# /packages/intranet-budget/www/reclassify.tcl
#
# Copyright (c) 2003-2020 ]project-open[
#
# All rights reserved. Please check
# http://www.project-open.com/license/ for details.

# ---------------------------------------------------------------
# Page Contract
# ---------------------------------------------------------------

ad_page_contract {
    Reclassify all cost items in this project
    @author frank.bergmann@project-open.com
} {
    project_id:integer
}

set current_user_id [auth::require_login]

# ---------------------------------------------------------------
# Permissions
# ---------------------------------------------------------------

im_project_permissions $current_user_id $project_id view_p read_p write_p admin_p

set result ""
if {$write_p} {

    db_dml reclassify "
	update im_costs
	set budget_item_id = null
	where cost_id in (
		select	c.cost_id
		from	im_costs c,
			im_projects p,
			im_projects main_p
		where	main_p.project_id = :project_id and
			p.tree_sortkey between main_p.tree_sortkey and tree_right(main_p.tree_sortkey) and
			p.project_id = c.project_id
	)
    "

    set http_code 200
    set success "true"
    set message "successfully reclassified"
} else {
    set http_code 403
    set success "false"
    set message "You have not enough rights to reclassify costs in this project."
}

doc_return $http_code "application/json" "{\"success\": $success, \"message\": \"$message\"}"

