# /packages/intranet-budget/www/versions/delete.tcl
#
# Copyright (C) 2003-2019 ]project-open[
#
# All rights reserved. Please check
# http://www.project-open.com/license/ for details.

ad_page_contract {
    Takes commands from the /intranet-notes/index page or 
    the notes-list-compomponent and perform the selected 
    action an all selected notes.
    @author frank.bergmann@project-open.com
} {
    version_id:multiple,optional
    return_url
}

# ---------------------------------------------------------------
# Defaults & Security
# ---------------------------------------------------------------

set user_id [auth::require_login]

if {![info exists version_id] || "" eq $version_id} {
    aad_returnredirect $return_url 
}


set delete_p [im_permission $user_id fi_write_all]
if {!$delete_p} {
    ad_return_complaint 1 "<b>[lang::message::lookup "" intranet-timesheet2-workflow.Insufficient_permission "Insufficient permissions"]</b>"
    ad_script_abort
}

foreach cid $version_id {

    if {[im_table_exists im_planning_items]} {
        db_dml del_planning_items "delete from im_planning_items where item_version_id = :cid"
    }

    db_string del_conf_object "select im_budget_version__delete(:cid)" -default ""
}


ad_returnredirect $return_url

